/*****************************************************
Project : 
Version : 1
Date    : 01.08.2012
Author  : Laptev Alexey
Company : Dom

Chip type               : ATtiny45
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 64
*****************************************************/

#include <tiny45.h>

unsigned int rezult;
unsigned char overflow_0,peremen;

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
overflow_0++;
}

// Timer1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
  TCCR0B=0x00;
  TIMSK=0x00;
  TCNT1=0x00;
  rezult = ((overflow_0*256)+TCNT0);
  overflow_0=0;
  TIFR&=0x64;
  
  if (rezult<1) {
  TIFR&=0x60;
  TIMSK=0x42;
  peremen=5; 
  rezult=0; };
  
  if (rezult>=1) {
    if (rezult<=3) {
    peremen=1; 
    rezult=0; }; }; 
  
  if (rezult>3) {
    if (rezult<=7) {
    peremen=2; 
    rezult=0; }; }; 
  
  if (rezult>7) {
    if (rezult<=15) {
    peremen=3; 
    rezult=0; }; };
  
  if (rezult>15) { 
    if (rezult<=100) {
    peremen=4;
    rezult=0; }; };
    
  if (rezult>100) {
  TIFR&=0x64;
  TIMSK=0x42;
  peremen=5; 
  rezult=0; };
}

void reset(void) {
TCCR0B=0x06;
TCNT0=0x00;
TIFR=0x00;
TIMSK=0x42; }

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=Out Func3=Out Func2=In Func1=Out Func0=Out 
// State5=P State4=0 State3=0 State2=P State1=0 State0=0 
PORTB=0x24;
DDRB=0x1B;

// Timer/Counter 0 initialization
// Clock source: T0 pin Falling Edge
// Mode: Normal top=0xFF
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x06;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=0xFF
// OC1A output: Disconnected
// OC1B output: Disconnected
// Timer1 Overflow Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
PLLCSR=0x00;

TCCR1=0x0B;
GTCCR=0x00;
TCNT1=0x00;
OCR1A=0x4E;
OCR1B=0x00;
OCR1C=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x42;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;
DIDR0=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// Global enable interrupts
#asm("sei")

while (1)
      {
        if (peremen==1) {
        PORTB.1=1;
        PORTB.0=0;
        PORTB.4=0;
        PORTB.3=0;
        peremen=0;
        reset(); 
        };
        
        if (peremen==2) {
        PORTB.1=0;
        PORTB.0=1;
        PORTB.4=0;
        PORTB.3=0;
        peremen=0;
        reset(); 
        };
        
        if (peremen==3) {
        PORTB.1=0;
        PORTB.0=0;
        PORTB.4=1;
        PORTB.3=0;
        peremen=0;
        reset(); 
        };
          
        if (peremen==4) {
        PORTB.1=0;
        PORTB.0=0;
        PORTB.4=0;
        PORTB.3=1;
        peremen=0;
        reset(); 
        }; 
        
        if (peremen==5) {
        PORTB&=0xE4;
        peremen=0;
        reset(); 
        }; 
      }
}
